[CodeForces 118D]Caesar's Legions[DP]

题目链接: [CodeForces 118D]Caesar's Legions[DP]

题意分析:

凯撒有n1个步兵和n2个骑兵,现在将他们排成一列,问总共有多少种不同的排列情况?(步兵不能连着超过k1个,骑兵不能连着超过k2个)

解题思路:

首先倒着考虑状态看看行不行,比如已经放置了n1个步兵和n2个骑兵的方法总数,那么这个状态的上一个状态应该考虑到当前状态中,最后一个兵种是什么,然后考虑来的状态有多少个,发现这样考虑蛮复杂的。那么试试正着考虑:正着考虑,先想到从第i个位置出发,有多少种方法,发现这样的话,有三个东西不知道:当前的排头兵是什么兵种,这个兵种连续了几个,用了多少个这种兵种。那么悉数补上,就有dp[i][j][s][k]表示从第i个位置开始,步兵使用了j个,当前兵种为s(0:步兵,1:骑兵),连续了k个,然后就能转移了。

个人感受:

第二次做了。昨天还没思路= =,今天发现可以正着推,23333

具体代码如下:

#include<algorithm>
#include<cctype>
#include<cmath>
#include<cstdio>
#include<cstring>
#include<iomanip>
#include<iostream>
#include<map>
#include<queue>
#include<set>
#include<sstream>
#include<stack>
#include<string>
#define lowbit(x) (x & (-x))
#define root 1, n, 1
#define lson l, m, rt << 1
#define rson m + 1, r, rt << 1  1
#define ll long long
#define pr(x) cout << #x << " = " << (x) << '\n';
using namespace std;

const int MOD = 1e8;

int n1, n2, k1, k2;
int dp[300][111][2][20];

int dfs(int n, int num, int sta, int len) {
    //cout << n << '-' << num << '-' << sta << '-' << len << '\n';
    int &x = dp[n][num][sta][len];
    if (x != -1) return x;
    x = 0;
    if (n > n1 + n2) return 0;
    if (n == n1 + n2 && num == n1) return x = 1;

    if (sta == 0) {
        if (num + 1 <= n1 && len + 1 <= k1)
            x += dfs(n + 1, num + 1, 0, len + 1);
        if (n + 1 - num <= n2)
            x += dfs(n + 1, num, 1, 1);
    }
    else {
        if (num + 1 <= n1)
            x += dfs(n + 1, num + 1, 0, 1);
        if (len + 1 <= k2 && n + 1 - num <= n2)
            x += dfs(n + 1, num, 1, len + 1);
    }
    return x % MOD;
}

int main()
{
    cin >> n1 >> n2 >> k1 >> k2;
    memset(dp, -1, sizeof dp);
    cout << dfs(0, 0, 0, 0) << '\n';
    return 0;
}


你可能感兴趣的:(dp)